# Class BigDecimal

java.lang.Object
com.codename1.util.BigDecimal

public class BigDecimal extends Object
Class representing a simple version of a big decimal. A `BigDecimal` is basically a `BigInteger` with a few digits on the right of the decimal point. The number of (binary) digits on the right of the decimal point is called the `scale` of the `BigDecimal`. Unlike in `BigDecimal`, the scale is not adjusted automatically, but must be set manually. All `BigDecimal`s taking part in the same arithmetic operation must have equal scale. The result of a multiplication of two `BigDecimal`s returns a `BigDecimal` with double scale.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BigDecimal(BigInteger bigInt, int scale)`
  Constructor for `BigDecimal`.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `BigDecimal`
  `add(BigDecimal b)`
  `BigDecimal`
  `add(BigInteger b)`
  `BigDecimal`
  `adjustScale(int newScale)`
  `int`
  `compareTo(BigDecimal val)`
  `int`
  `compareTo(BigInteger val)`
  `BigDecimal`
  `divide(BigDecimal b)`
  `BigDecimal`
  `divide(BigInteger b)`
  `boolean`
  `equals(Object o)`
  Indicates whether some other object is "equal to" this one.
  `BigInteger`
  `floor()`
  `static BigDecimal`
  `getInstance(BigInteger value, int scale)`
  Returns a `BigDecimal` with value `value / 2scale / 10scale`
  `int`
  `getScale()`
  `int`
  `hashCode()`
  Returns a hash code value for the object.
  `int`
  `intValue()`
  `long`
  `longValue()`
  `BigDecimal`
  `multiply(BigDecimal b)`
  `BigDecimal`
  `multiply(BigInteger b)`
  `BigDecimal`
  `negate()`
  `BigInteger`
  `round()`
  `BigDecimal`
  `shiftLeft(int n)`
  `BigDecimal`
  `subtract(BigDecimal b)`
  `BigDecimal`
  `subtract(BigInteger b)`
  `String`
  `toString()`
  Returns a string representation of the object.

  ### Methods inherited from class Object

  `clone, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### BigDecimal

    public BigDecimal(BigInteger bigInt, int scale)

    Constructor for `BigDecimal`. The value of the constructed `BigDecimal` equals `bigInt / 10scale`.

    ###### Parameters

    - `bigInt`: The `bigInt` value parameter.

    - `scale`: The scale of the constructed `BigDecimal`.

- ## Method Details

  - ### getInstance

    public static BigDecimal getInstance(BigInteger value, int scale)

    Returns a `BigDecimal` with value `value / 2scale / 10scale`

    ###### Parameters

    - `value`: @param value The value of the `BigDecimal` to be created.

    - `scale`: @param scale The scale of the `BigDecimal` to be created.

    ###### Returns

    The such created `BigDecimal`.

    ###### Deprecated

  - ### adjustScale

    public BigDecimal adjustScale(int newScale)

  - ### add

    public BigDecimal add(BigDecimal b)

  - ### add

    public BigDecimal add(BigInteger b)

  - ### negate

    public BigDecimal negate()

  - ### subtract

    public BigDecimal subtract(BigDecimal b)

  - ### subtract

    public BigDecimal subtract(BigInteger b)

  - ### multiply

    public BigDecimal multiply(BigDecimal b)

  - ### multiply

    public BigDecimal multiply(BigInteger b)

  - ### divide

    public BigDecimal divide(BigDecimal b)

  - ### divide

    public BigDecimal divide(BigInteger b)

  - ### shiftLeft

    public BigDecimal shiftLeft(int n)

  - ### compareTo

    public int compareTo(BigDecimal val)

  - ### compareTo

    public int compareTo(BigInteger val)

  - ### floor

    public BigInteger floor()

  - ### round

    public BigInteger round()

  - ### intValue

    public int intValue()

  - ### longValue

    public long longValue()

  - ### getScale

    public int getScale()

  - ### toString

    public String toString()
    Description copied from class: `Object`
    Returns a string representation of the object. In general, the toString method returns a string that "textually represents" this object. The result should be a concise but informative representation that is easy for a person to read. It is recommended that all subclasses override this method. The toString method for class Object returns a string consisting of the name of the class of which the object is an instance, the at-sign character `@', and the unsigned hexadecimal representation of the hash code of the object. In other words, this method returns a string equal to the value of: getClass().getName() + '@' + Integer.toHexString(hashCode())
    Overrides:
      `toString` in class `Object`

  - ### equals

    public boolean equals(Object o)
    Description copied from class: `Object`
    Indicates whether some other object is "equal to" this one. The equals method implements an equivalence relation: It is reflexive: for any reference value x, x.equals(x) should return true. It is symmetric: for any reference values x and y, x.equals(y) should return true if and only if y.equals(x) returns true. It is transitive: for any reference values x, y, and z, if x.equals(y) returns true and y.equals(z) returns true, then x.equals(z) should return true. It is consistent: for any reference values x and y, multiple invocations of x.equals(y) consistently return true or consistently return false, provided no information used in equals comparisons on the object is modified. For any non-null reference value x, x.equals(null) should return false. The equals method for class Object implements the most discriminating possible equivalence relation on objects; that is, for any reference values x and y, this method returns true if and only if x and y refer to the same object (x==y has the value true).
    Overrides:
      `equals` in class `Object`

  - ### hashCode

    public int hashCode()
    Description copied from class: `Object`
    Returns a hash code value for the object. This method is supported for the benefit of hashtables such as those provided by java.util.Hashtable. The general contract of hashCode is: Whenever it is invoked on the same object more than once during an execution of a Java application, the hashCode method must consistently return the same integer, provided no information used in equals comparisons on the object is modified. This integer need not remain consistent from one execution of an application to another execution of the same application. If two objects are equal according to the equals(Object) method, then calling the hashCode method on each of the two objects must produce the same integer result. It is not required that if two objects are unequal according to the equals(java.lang.Object) method, then calling the hashCode method on each of the two objects must produce distinct integer results. However, the programmer should be aware that producing distinct integer results for unequal objects may improve the performance of hashtables. As much as is reasonably practical, the hashCode method defined by class Object does return distinct integers for distinct objects. (This is typically implemented by converting the internal address of the object into an integer, but this implementation technique is not required by the JavaTM programming language.)
    Overrides:
      `hashCode` in class `Object`